# Exercise Generalized assignment

# DATA
param N;					# Number of jobs
set Jobs := 1..N;			# Set of jobs
param M;					# Number of machines
set Machines := 1..M;		# Set of machines
param b {Machines};			# Capacity of each machine
param a {Jobs};				# Resource consumption for each job
param c {Jobs,Machines};	# Cost for each assignment

# VARIABLES
var x {Jobs,Machines} binary;	# Assignment variables

# CONSTRAINTS
# Assignment constraints for each job
subject to Assignment {i in Jobs}:
  sum {j in Machines} x[i,j] = 1;
  
# Capacity constraints for each machine
subject to Capacity {j in Machines}:
  sum {i in Jobs} a[i] * x[i,j] <= b[j];

# OBJECTIVE
# Minimize total cost of the assignments
minimize z: sum {i in Jobs,j in Machines} c[i,j] * x[i,j];

####################
data;
param N := 9;
param M := 3;
param b :=
1		380
2		360
3		350;

param a :=
1	100
2	111
3	 98
4	132
5	120
6	115
7	142
8	123
9	 90;

param c: 1	2	3 :=
1		24	42	23
2		30	45	23
3		33	54	16
4		37	45	18
5		34	47	22
6		31	42	25
7		30	41	19
8		28	47	15
9		25	50	20;

end;
